#include <BluetoothSerial.h>
#if !defined(CONFIG_BT_ENABLED) || !defined(CONFIG_BLUEDROID_ENABLED)
#error Bluetooth is not enabled! Please run `make menuconfig` to and enable it
#endif
BluetoothSerial SerialBT;

#include "defin.h"
#include "gyro_acsel.h"
#include "step_motor.h" // Обслуживание шаговых моторов
#include "fromsmart.h" // Обслуживание шаговых моторов


double   _1_d_131 = 1.0 * DEG_TO_RAD / 131.0;
double Acsel = 0;
double Gyro = 0;

void setup() {
  setup_motor_system();
  Serial.println("Do");
  motor_off();

  Serial.begin(115200);
  Serial.println();

  SerialBT.begin("BARSIK"); //Имя робота в BT
  giroscop_setup();
  delay(100);
  //  Calc_CompensatorZ(2000);
  t0 = micros() - 5000;
  t2 = micros();
  Speed = 0;
}

void loop()
{
  t_period = 5000;
  static int i = 0; // для торможения вывода
  uint64_t micros_;
  micros_ = micros();
  if (micros_ < t2) return;//Если период < t2 анализ. прошло 5000 если да, измеряем угловую скорость.
  BT_input();
  //Опрос гироприбора:
  //bno.getEvent(&event); // Берем сразу углы Эйлера
  dt = micros() - t0; // Длительность предыдущего периода регулирования.
  t0 += dt; //Точка начала нового периода регулирования.
  double Dt = double(dt) * 0.000001;
  // Нужно поймать угол, рядом с которым угловая скорость колеблется в районе нуля.
  OldAcYsum = AcYsum;
  Data_mpu6050();
  //Расчет угла по показаниям акселерометра
  Acsel = (atan2(AcX, AcZ));// * RAD_TO_DEG;
  //Acsel = (atan2(AcY, AcZ));// * RAD_TO_DEG;
  // скорость угловая В радианах - падения
  Gyro = - (float(GyY) - CompensatorY)  * _1_d_131;
  //Gyro = - (float(GyX) - CompensatorY)  * _1_d_131;
  //Комплементарный фильтр
  AcYsum = ONE_ALFA * (OldAcYsum + Gyro * Dt) + ALFA * Acsel;
  t2 = t0 + t_period;
  if (i > 20)
  {
    i = 0;
    Serial.print("GYRO="); Serial.print(Gyro);
    Serial.print("    Acsel="); Serial.print(Acsel);
    Serial.print("    AcYsum ="); Serial.print(AcYsum);
    Serial.println();
  }
  i++;
}



bool stay_from_off() //Встать из положения сидя/лежа
{

}
