//Указатели на таймеры
hw_timer_t * timerL = NULL; //Таймеры задающие высокий уровень (срабатывают периодически с заданной частотой)
hw_timer_t * timerR = NULL;

hw_timer_t * timerLlower = NULL; //Таймеры отключающие высокий уровень (срабатывают один раз после приказа)
hw_timer_t * timerRlower = NULL; //Таймеры отключающие высокий уровень (срабатывают один раз после приказа)

#define STEP_L 15 //Пин левого шага 
#define STEP_R 4 //Пин правого шага
#define STEPER_EN 2 //Пин врключения моторов// Функция инициализации уравления моторами.//////////////////////////////

#define DIR_L 13 //Пин направления левого шага 
#define DIR_R 16 //Пин направления правого шага

#define DIR_L_FRONT false //Пин направления левого шага 
#define DIR_R_FRONT true //Пин направления правого шага

#define DIR_L_BACK true //Пин направления левого шага 
#define DIR_R_BACK false //Пин направления правого шага

const uint32_t max_div_sp = 320; // На шаг Достигаемый нижний предел (самый маленький шаг)
const uint32_t min_div_sp = 100000; // На шаг
const uint32_t stops_div =  50000;
// Объявляем переменные для хранения состояния двух моторов.
bool STEP_L_level = false;
bool STEP_R_level = false;
//=========================================
uint32_t speed_stepL;
uint32_t speed_stepR;
//=========================================
//=========================================
bool timer_volumeL;
bool timer_volumeR;
//=========================================
//=========================================
bool DIR_L_level = false;
bool DIR_R_level = false;
//=========================================
//=========================================
bool flag_off = false; //Флаг отключения двигателя
//=========================================

bool STEPER_EN_level = true;

int timer_stop; // для отключения двигателей при простое

#include "irq_robot.h"

//===============================
void setup_motor_system()
{
  STEP_L_level = false;
  STEP_R_level = false;
  DIR_L_level = false;
  DIR_R_level = false;
  STEPER_EN_level = true;

  pinMode(STEP_L, OUTPUT);
  pinMode(STEP_R, OUTPUT);
  pinMode(DIR_L, OUTPUT);
  pinMode(DIR_R, OUTPUT);
  pinMode(STEPER_EN, OUTPUT);

  digitalWrite(STEP_L, STEP_L_level);
  digitalWrite(STEP_R, STEP_R_level);
  digitalWrite(DIR_L, DIR_L_level);
  digitalWrite(DIR_R, DIR_R_level);
  digitalWrite(STEPER_EN, STEPER_EN_level);
  timer_volumeL = true;
  timer_volumeR = true;
    //============================
  timerL = timerBegin(0, 80, true);
  timerR = timerBegin(1, 80, true);
  
  timerLlower = timerBegin(2, 80, true);
  timerRlower = timerBegin(3, 80, true);
  
  // Attach onTimer function to our timer.
  timerAttachInterrupt(timerL, &onTimerL_rec, true);
  timerAlarmWrite(timerL, 1000, true);
  timerAttachInterrupt(timerR, &onTimerR_rec, true);
  timerAlarmWrite(timerR, 1000, true);
  
  timerAttachInterrupt(timerLlower, &onTimerLlower, true);
  timerAlarmWrite(timerLlower, 10, false); //Третий параметр (false) задает, что таймер сработает только один раз
  timerAttachInterrupt(timerRlower, &onTimerRlower, true);
  timerAlarmWrite(timerRlower, 10, false); //Третий параметр (false) задает, что таймер сработает только один раз
  
  timer_volumeL  = false;
  timer_volumeR  = false;
}
//===============================
//===============================

// == Включение /отключние моторов
void motor_off()
{
  // Отключаем все колеса.
  if (!STEPER_EN_level)
  {
    STEPER_EN_level = true;
    digitalWrite(STEPER_EN, STEPER_EN_level);
  }
}
//===============================
void motor_on()
{
  // Включаем все колеса.
  if (STEPER_EN_level)
  {
    STEPER_EN_level = false;
    digitalWrite(STEPER_EN, STEPER_EN_level);
  }
}
//===============================
// Устанавливаем скорость согласно расчетам
void SetSpeed()
{
  motor_on();
  if (SpeedL == 0)
  {
    timerAlarmDisable(timerL);  //НЕ шагаем
  }
  else
  {
    // Для шага внутри прерывания
    int32_t speed_1 = int32_t(1000000.0 / SpeedL); //(1000000.0/(2*speed));
    if (speed_1 > 0)
    {
      DIR_L_level = DIR_L_FRONT;
    }
    else
    {
      DIR_L_level = DIR_L_BACK;
      speed_1 = -speed_1;
    }
    speed_1 = constrain(speed_1, max_div_sp, min_div_sp);
    timerAlarmDisable(timerL);
    digitalWrite(DIR_L, DIR_L_level);
    speed_stepL = uint32_t(speed_1) ;
    timerAlarmWrite(timerL, speed_stepL, true);
    timerAlarmEnable(timerL);
  }
  ///-------------------
  if (SpeedR == 0)
  {
    timerAlarmDisable(timerR);  //НЕ шагаем
  }
  else
  {
    // Для шага внутри прерывания
    int32_t speed_1 = int32_t(1000000.0 / SpeedR); //(1000000.0/(2*speed));
    if (speed_1 > 0)
    {
      DIR_R_level = DIR_R_FRONT;
    }
    else
    {
      DIR_R_level = DIR_R_BACK;
      speed_1 = -speed_1;
    }
    speed_1 = constrain(speed_1, max_div_sp, min_div_sp);
    timerAlarmDisable(timerR);
    digitalWrite(DIR_R, DIR_R_level);
    speed_stepR = uint32_t(speed_1) ;
    timerAlarmWrite(timerR, speed_stepR, true);
    timerAlarmEnable(timerR);
  }
}
